/*
 * Minimalizacja funkcji wielu zmiennych ("Projekt systemu")
 * Bartlomiej Brzozowiec, VIII 2005
 */
//---------------------------------------------------------------------------
// ((jakby co, to arg. domyslne umieszcza sie w deklaracji f./m.))
//---------------------------------------------------------------------------
// klasa abstrakcyjna, po ktorej dziedzicza konkretne metody

#ifndef _METODAMINIM_H
#define _METODAMINIM_H

#include <valarray>

class MetodaMinim {
        public:
                virtual void OKilzm() = 0;
                virtual bool Licz() = 0;
                virtual void Posprzataj() = 0;

        // protected, czyli private dla klasy _oraz_ private w potomkach
        protected:
                // zakomentowane, bo byly problemy z linkowaniem...
                //template<class T>
                //bool WpiszWersory( std::valarray<T>& va, int ile_wierszy, int ile_kolumn );
                bool WpiszWersory( std::valarray<double>& va, int ile_wierszy, int ile_kolumn );
                // zwraca wart. f. w punkcie; korzysta z zewn. zrodel...
                double WartF( const std::valarray<double>& va );
                void PokazWynik( const std::valarray<double>& va );
};

#endif

