/*
 * Minimalizacja funkcji wielu zmiennych ("Projekt systemu")
 * Bartlomiej Brzozowiec, X 2005, Joensuu
 */
//---------------------------------------------------------------------------

#ifndef _GAUSSSEIDEL_H
#define _GAUSSSEIDEL_H

#include <valarray>
#include "MetodaMinim.h"
#include "Unit1.h"

class GaussSeidel : public MetodaMinim {
        private:
                // zmienne
                double tau;
                // metody
                bool pobierz_tau( void );
        public:
                // konstruktor
                GaussSeidel();

                void OKilzm();
                bool Licz();
                void Posprzataj();
};

#endif
